/*
  ==============================================================================

    This file was auto-generated!

    It contains the basic framework code for a JUCE plugin processor.

  ==============================================================================
*/

#ifndef PLUGINPROCESSOR_H_INCLUDED
#define PLUGINPROCESSOR_H_INCLUDED

#include "../JuceLibraryCode/JuceHeader.h"
#include "StereoWidthCtrl.h"

//==============================================================================
/**
*/
class StereoWidthCtrlAudioProcessor : public AudioProcessor,
									  public AudioProcessorValueTreeState::Listener
{
public:
    //==============================================================================
    StereoWidthCtrlAudioProcessor();
    ~StereoWidthCtrlAudioProcessor();

    //==============================================================================
    void prepareToPlay (double sampleRate, int samplesPerBlock) override;
    void releaseResources() override;

   #ifndef JucePlugin_PreferredChannelConfigurations
    bool setPreferredBusArrangement (bool isInput, int bus, const AudioChannelSet& preferredSet) override;
   #endif

    void processBlock (AudioSampleBuffer&, MidiBuffer&) override;

    //==============================================================================
    AudioProcessorEditor* createEditor() override;
    bool hasEditor() const override;

    //==============================================================================
    const String getName() const override;

    bool acceptsMidi() const override;
    bool producesMidi() const override;
    double getTailLengthSeconds() const override;

    //==============================================================================
    int getNumPrograms() override;
    int getCurrentProgram() override;
    void setCurrentProgram (int index) override;
    const String getProgramName (int index) override;
    void changeProgramName (int index, const String& newName) override;

    //==============================================================================
    void getStateInformation (MemoryBlock& destData) override;
    void setStateInformation (const void* data, int sizeInBytes) override;

	//Parameters and access
#define PARAM_SETNAME "StereoWidthParams"
#define PARAM_BYPASS "Bypass"
#define PARAM_WIDTH	"StereoWidth"

	AudioProcessorValueTreeState& getState() { return *mState; };
	void parameterChanged(const String& parameterID, float newValue) { MajorParamChange = true; }; //override 

private:
	bool MajorParamChange;
	ScopedPointer<AudioProcessorValueTreeState> mState;
	ScopedPointer<UndoManager>                  mUndoManager;

	//DSP
	StereoWidthCtrl mWidthControl;

    //==============================================================================
    JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR (StereoWidthCtrlAudioProcessor)
};


#endif  // PLUGINPROCESSOR_H_INCLUDED
